type Id = String

data SKI = S | K | I | B | C | App SKI SKI | Var Id deriving (Show, Eq)
data Lambda = V Id | A Lambda Lambda | Abs Id Lambda deriving (Show, Eq)

fv (Var id) = [id]
fv (App e1 e2) = fv e1 ++ fv e2
fv _ = []

freeIn id term = id `elem` fv term

lambda2ski :: Lambda -> SKI
lambda2ski (V id) = Var id
lambda2ski (A e1 e2) = App (lambda2ski e1) (lambda2ski e2)
lambda2ski (Abs id term) = lamb id $ lambda2ski term

lamb id term        | not (id `freeIn` term) = App K term
lamb id (Var id')   | id == id'              = I
lamb id (App e1 (Var id')) 
  | id == id' && not (id `freeIn` e1)        = e1                  
lamb id (App e1 e2) | not (id `freeIn` e1)   = App (App B e1) (lamb id e2)
lamb id (App e1 e2) | not (id `freeIn` e2)   = App (App C (lamb id e1)) e2
lamb id (App e1 e2)                          = App (App S (lamb id e1)) (lamb id e2)

-- lambda2ski (Abs id (A e (V id'))) 
--   | id == id' && not (id `freeIn` lambda2ski e) = lambda2ski e

ski2ltac S = "S. "
ski2ltac K = "K. "
ski2ltac I = "I. "
ski2ltac B = "B. "
ski2ltac C = "C. "
ski2ltac (App s1 s2) = "mp. " ++ ski2ltac s1 ++ ski2ltac s2
ski2ltac (Var id) = "apply " ++ id ++ ". "

c = Abs "f" (Abs "x" (Abs "y" (A (A f y) x)))
b = Abs "f" (Abs "g" (Abs "x" (A f (A g x))))

f = V "f"
g = V "g"
h = V "h"
h1 = V "h1"
h2 = V "h2"
x = V "x"
y = V "y"
z = V "z"

convert = ski2ltac . lambda2ski

term1 = (Abs "f" (Abs "h1" (Abs "h2" (Abs "x" (A (A f (Abs "y" (A (A h1 y) x))) (Abs "y" (A (A h2 y) x)))))))

term2 = (Abs "x" (Abs "y" (Abs "f" (A (A f x) y))))

term3 = (Abs "x" (Abs "h" (A h (Abs "y" x))))

term4 = (Abs "f" (Abs "x" (Abs "y" (A (A (V "IH") (Abs "z" (A (A f z) y))) x))))

term5 = Abs "x" x

term6 = Abs "x" 
      (A 
      (A (V "H2") (A (V "H1") (A (V "ax_andE2") x))) 
      (A (V "ax_andE1") x)) 

term7 = Abs "f" (Abs "x" (Abs "y" (A f (A (A (V "ax_aI") x) y) ))) 

term8 = Abs "f" (Abs "x" (A (V "Y") (A f (A (V "X") x)))) 